import * as z from 'zod';
import type { Prisma } from '../../../generated/prisma';
import { ClaimArgsObjectSchema as ClaimArgsObjectSchema } from './ClaimArgs.schema';
import { PatientArgsObjectSchema as PatientArgsObjectSchema } from './PatientArgs.schema';
import { UserArgsObjectSchema as UserArgsObjectSchema } from './UserArgs.schema';
import { NpiProviderArgsObjectSchema as NpiProviderArgsObjectSchema } from './NpiProviderArgs.schema';
import { ServiceLineTransactionFindManySchema as ServiceLineTransactionFindManySchema } from '../findManyServiceLineTransaction.schema';
import { ServiceLineFindManySchema as ServiceLineFindManySchema } from '../findManyServiceLine.schema';
import { CommissionBatchItemFindManySchema as CommissionBatchItemFindManySchema } from '../findManyCommissionBatchItem.schema';
import { PaymentCountOutputTypeArgsObjectSchema as PaymentCountOutputTypeArgsObjectSchema } from './PaymentCountOutputTypeArgs.schema'

const makeSchema = () => z.object({
  id: z.boolean().optional(),
  claimId: z.boolean().optional(),
  patientId: z.boolean().optional(),
  userId: z.boolean().optional(),
  updatedById: z.boolean().optional(),
  npiProviderId: z.boolean().optional(),
  totalBilled: z.boolean().optional(),
  totalPaid: z.boolean().optional(),
  totalAdjusted: z.boolean().optional(),
  totalDue: z.boolean().optional(),
  mhPaidAmount: z.boolean().optional(),
  copayment: z.boolean().optional(),
  adjustment: z.boolean().optional(),
  status: z.boolean().optional(),
  notes: z.boolean().optional(),
  icn: z.boolean().optional(),
  createdAt: z.boolean().optional(),
  updatedAt: z.boolean().optional(),
  claim: z.union([z.boolean(), z.lazy(() => ClaimArgsObjectSchema)]).optional(),
  patient: z.union([z.boolean(), z.lazy(() => PatientArgsObjectSchema)]).optional(),
  updatedBy: z.union([z.boolean(), z.lazy(() => UserArgsObjectSchema)]).optional(),
  npiProvider: z.union([z.boolean(), z.lazy(() => NpiProviderArgsObjectSchema)]).optional(),
  serviceLineTransactions: z.union([z.boolean(), z.lazy(() => ServiceLineTransactionFindManySchema)]).optional(),
  serviceLines: z.union([z.boolean(), z.lazy(() => ServiceLineFindManySchema)]).optional(),
  commissionBatchItems: z.union([z.boolean(), z.lazy(() => CommissionBatchItemFindManySchema)]).optional(),
  _count: z.union([z.boolean(), z.lazy(() => PaymentCountOutputTypeArgsObjectSchema)]).optional()
}).strict();
export const PaymentSelectObjectSchema: z.ZodType<Prisma.PaymentSelect> = makeSchema() as unknown as z.ZodType<Prisma.PaymentSelect>;
export const PaymentSelectObjectZodSchema = makeSchema();
